;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Instance <List_T> of the theory ListWithLength
;; List_T-template.smt

 :extrasorts (<List_T>)

 :extrafuns ((nil_<List_T> <List_T>)
             (cons_<List_T> <T> <List_T> <List_T>)
             (head_<List_T> <List_T> <T>)
             (tail_<List_T> <List_T> <List_T>)
             (append_<List_T> <List_T> <List_T> <List_T>)
             (length_<List_T> <List_T> Int)
             (nth_<List_T> Int <List_T> <T>))

;; Nil and cons have different values

 :assumption (forall (?x <T>) (?y <List_T>)
                     (not (= (cons_<List_T> ?x ?y) nil_<List_T>))
              :pat { (cons_<List_T> ?x ?y) } )

;; Head and tail as the inverses of cons

 :assumption (forall (?x <T>) (?y <List_T>)
                     (and (= (head_<List_T> (cons_<List_T> ?x ?y)) ?x)
                          (= (tail_<List_T> (cons_<List_T> ?x ?y)) ?y))
              :pat { (cons_<List_T> ?x ?y) } )

;; Recursive definition of append

 :assumption (forall (?x <List_T>)
                     (= (append_<List_T> nil_<List_T> ?x) ?x)
              :pat { (append_<List_T> nil_<List_T> ?x) } )

 :assumption (forall (?x <List_T>) (?y <T>) (?z <List_T>)
                     (= (append_<List_T> (cons_<List_T> ?y ?z) ?x)
                        (cons_<List_T> ?y (append_<List_T> ?z ?x)))
              :pat { (append_<List_T> (cons_<List_T> ?y ?z) ?x) } )

;; The length of lists

 :assumption (= (length_<List_T> nil_<List_T>) 0)

 :assumption (forall (?x <List_T>) (>= (length_<List_T> ?x) 0)
              :pat { (length_<List_T> ?x) } )

 :assumption (forall (?x <T>) (?y <List_T>)
                     (= (length_<List_T> (cons_<List_T> ?x ?y))
                        (+ 1 (length_<List_T> ?y)))
              :pat { (length_<List_T> (cons_<List_T> ?x ?y)) } )

 :assumption (forall (?x <List_T>) (?y <List_T>)
                     (= (length_<List_T> (append_<List_T> ?x ?y))
                        (+ (length_<List_T> ?x) (length_<List_T> ?y)))
              :pat { (length_<List_T> (append_<List_T> ?x ?y)) } )

;; The nth element of a list

 :assumption (forall (?x <T>) (?y <List_T>) (?z Int)
                     (and (implies (= ?z 1)
                                   (= (nth_<List_T> ?z (cons_<List_T> ?x ?y)) ?x))
                          (implies (> ?z 1)
                                   (= (nth_<List_T> ?z (cons_<List_T> ?x ?y))
                                      (nth_<List_T> (- ?z 1) ?y))))
              :pat { (nth_<List_T> ?z (cons_<List_T> ?x ?y)) } )

 :assumption (forall (?x <List_T>) (?y <List_T>) (?z Int)
                     (and (implies (and (>= ?z 1) (<= ?z (length_<List_T> ?x)))
                                   (= (nth_<List_T> ?z (append_<List_T> ?x ?y))
                                      (nth_<List_T> ?z ?x)))
                          (implies (and (> ?z (length_<List_T> ?x))
                                        (<= ?z (length_<List_T> (append_<List_T> ?x ?y))))
                                   (= (nth_<List_T> ?z (append_<List_T> ?x ?y))
                                      (nth_<List_T> (- ?z (length_<List_T> ?x)) ?y))))
              :pat { (nth_<List_T> ?z (append_<List_T> ?x ?y)) } )

;; End: Instance <List_T> of the theory ListWithLength
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
