#ifndef ABSYN_HEADER
#define ABSYN_HEADER

//C++ Abstract Syntax Interface generated by the BNF Converter.

/********************   TypeDef Section    ********************/
typedef int Integer;
typedef char Char;
typedef double Double;
typedef char* String;
typedef char* Ident;
typedef char* Numeral;
typedef char* Rational;
typedef char* Hexadecimal;
typedef char* Binary;
typedef char* Symbol;
typedef char* AnnotAttribute;


/********************   Forward Declarations    ********************/

class Benchmark;
class LogicAttribute;
class FamilyAttribute;
class AssumptionAttribute;
class FormulaAttribute;
class StatusAttribute;
class ExtraSortsAttribute;
class ExtraFunsAttribute;
class NotesAttribute;
class AnnotationAttribute;
class ListAttribute;
class SatStatus;
class UnSatStatus;
class UnknownStatus;
class IdentSort;
class CompositeSort;
class ListSort;
class SortDecl;
class SortSynonymDecl;
class ListSortDeclC;
class ConstantTerm;
class NullaryTerm;
class FunctionTerm;
class LetTerm;
class QuantifierTerm;
class AnnotationTerm;
class ListTerm;
class Binding;
class ListBindingC;
class AllQuantifier;
class ExQuantifier;
class IdentifierRef;
class CastIdentifierRef;
class ConstantDecl;
class MetaConstantDecl;
class FunctionDecl;
class MacroDecl;
class ListFunctionDeclC;
class SortedVariable;
class ListSortedVariableC;
class NumConstant;
class RatConstant;
class HexConstant;
class BinConstant;
class StringConstant;
class NumMetaConstant;
class RatMetaConstant;
class HexMetaConstant;
class BinMetaConstant;
class StringMetaConstant;
class SymbolIdent;
class IndexIdent;
class Index;
class ListIndexC;
class AttrAnnotation;
class ListAnnotation;
class SomeAttrParam;
class NoAttrParam;
class ConstantSExpr;
class SymbolSExpr;
class ParenSExpr;
class ListSExpr;
class BenchmarkC;
class Attribute;
class Status;
class Sort;
class SortDeclC;
class Term;
class BindingC;
class Quantifier;
class SymbolRef;
class FunctionDeclC;
class SortedVariableC;
class SpecConstant;
class MetaConstant;
class Identifier;
class IndexC;
class Annotation;
class AttrParam;
class SExpr;


/********************   Visitor Interfaces    ********************/

class Visitor
{
 public:
  virtual ~Visitor() {}
  virtual void visitBenchmark(Benchmark *p) = 0;
  virtual void visitLogicAttribute(LogicAttribute *p) = 0;
  virtual void visitFamilyAttribute(FamilyAttribute *p) = 0;
  virtual void visitAssumptionAttribute(AssumptionAttribute *p) = 0;
  virtual void visitFormulaAttribute(FormulaAttribute *p) = 0;
  virtual void visitStatusAttribute(StatusAttribute *p) = 0;
  virtual void visitExtraSortsAttribute(ExtraSortsAttribute *p) = 0;
  virtual void visitExtraFunsAttribute(ExtraFunsAttribute *p) = 0;
  virtual void visitNotesAttribute(NotesAttribute *p) = 0;
  virtual void visitAnnotationAttribute(AnnotationAttribute *p) = 0;
  virtual void visitListAttribute(ListAttribute *p) = 0;
  virtual void visitSatStatus(SatStatus *p) = 0;
  virtual void visitUnSatStatus(UnSatStatus *p) = 0;
  virtual void visitUnknownStatus(UnknownStatus *p) = 0;
  virtual void visitIdentSort(IdentSort *p) = 0;
  virtual void visitCompositeSort(CompositeSort *p) = 0;
  virtual void visitListSort(ListSort *p) = 0;
  virtual void visitSortDecl(SortDecl *p) = 0;
  virtual void visitSortSynonymDecl(SortSynonymDecl *p) = 0;
  virtual void visitListSortDeclC(ListSortDeclC *p) = 0;
  virtual void visitConstantTerm(ConstantTerm *p) = 0;
  virtual void visitNullaryTerm(NullaryTerm *p) = 0;
  virtual void visitFunctionTerm(FunctionTerm *p) = 0;
  virtual void visitLetTerm(LetTerm *p) = 0;
  virtual void visitQuantifierTerm(QuantifierTerm *p) = 0;
  virtual void visitAnnotationTerm(AnnotationTerm *p) = 0;
  virtual void visitListTerm(ListTerm *p) = 0;
  virtual void visitBinding(Binding *p) = 0;
  virtual void visitListBindingC(ListBindingC *p) = 0;
  virtual void visitAllQuantifier(AllQuantifier *p) = 0;
  virtual void visitExQuantifier(ExQuantifier *p) = 0;
  virtual void visitIdentifierRef(IdentifierRef *p) = 0;
  virtual void visitCastIdentifierRef(CastIdentifierRef *p) = 0;
  virtual void visitConstantDecl(ConstantDecl *p) = 0;
  virtual void visitMetaConstantDecl(MetaConstantDecl *p) = 0;
  virtual void visitFunctionDecl(FunctionDecl *p) = 0;
  virtual void visitMacroDecl(MacroDecl *p) = 0;
  virtual void visitListFunctionDeclC(ListFunctionDeclC *p) = 0;
  virtual void visitSortedVariable(SortedVariable *p) = 0;
  virtual void visitListSortedVariableC(ListSortedVariableC *p) = 0;
  virtual void visitNumConstant(NumConstant *p) = 0;
  virtual void visitRatConstant(RatConstant *p) = 0;
  virtual void visitHexConstant(HexConstant *p) = 0;
  virtual void visitBinConstant(BinConstant *p) = 0;
  virtual void visitStringConstant(StringConstant *p) = 0;
  virtual void visitNumMetaConstant(NumMetaConstant *p) = 0;
  virtual void visitRatMetaConstant(RatMetaConstant *p) = 0;
  virtual void visitHexMetaConstant(HexMetaConstant *p) = 0;
  virtual void visitBinMetaConstant(BinMetaConstant *p) = 0;
  virtual void visitStringMetaConstant(StringMetaConstant *p) = 0;
  virtual void visitSymbolIdent(SymbolIdent *p) = 0;
  virtual void visitIndexIdent(IndexIdent *p) = 0;
  virtual void visitIndex(Index *p) = 0;
  virtual void visitListIndexC(ListIndexC *p) = 0;
  virtual void visitAttrAnnotation(AttrAnnotation *p) = 0;
  virtual void visitListAnnotation(ListAnnotation *p) = 0;
  virtual void visitSomeAttrParam(SomeAttrParam *p) = 0;
  virtual void visitNoAttrParam(NoAttrParam *p) = 0;
  virtual void visitConstantSExpr(ConstantSExpr *p) = 0;
  virtual void visitSymbolSExpr(SymbolSExpr *p) = 0;
  virtual void visitParenSExpr(ParenSExpr *p) = 0;
  virtual void visitListSExpr(ListSExpr *p) = 0;
  virtual void visitBenchmarkC(BenchmarkC *p) = 0;
  virtual void visitAttribute(Attribute *p) = 0;
  virtual void visitStatus(Status *p) = 0;
  virtual void visitSort(Sort *p) = 0;
  virtual void visitSortDeclC(SortDeclC *p) = 0;
  virtual void visitTerm(Term *p) = 0;
  virtual void visitBindingC(BindingC *p) = 0;
  virtual void visitQuantifier(Quantifier *p) = 0;
  virtual void visitSymbolRef(SymbolRef *p) = 0;
  virtual void visitFunctionDeclC(FunctionDeclC *p) = 0;
  virtual void visitSortedVariableC(SortedVariableC *p) = 0;
  virtual void visitSpecConstant(SpecConstant *p) = 0;
  virtual void visitMetaConstant(MetaConstant *p) = 0;
  virtual void visitIdentifier(Identifier *p) = 0;
  virtual void visitIndexC(IndexC *p) = 0;
  virtual void visitAnnotation(Annotation *p) = 0;
  virtual void visitAttrParam(AttrParam *p) = 0;
  virtual void visitSExpr(SExpr *p) = 0;

  virtual void visitInteger(Integer i) = 0;
  virtual void visitDouble(Double d) = 0;
  virtual void visitChar(Char c) = 0;
  virtual void visitString(String s) = 0;
};


class Visitable
{
 public:
  virtual ~Visitable() {}
  virtual void accept(Visitor *v) = 0;
};



/********************   Abstract Syntax Classes    ********************/

class BenchmarkC : public Visitable {
public:
  virtual BenchmarkC *clone() const = 0;
};

class Benchmark : public BenchmarkC
{
 public:
  Symbol symbol_;
  ListAttribute *listattribute_;

  Benchmark(const Benchmark &);
  Benchmark &operator=(const Benchmark &);
  Benchmark(Symbol p1, ListAttribute *p2);
  ~Benchmark();
  virtual void accept(Visitor *v);
  virtual  Benchmark  *clone() const;
  void swap(Benchmark &);
};


class Attribute : public Visitable {
public:
  virtual Attribute *clone() const = 0;
};

class LogicAttribute : public Attribute
{
 public:
  Symbol symbol_;

  LogicAttribute(const LogicAttribute &);
  LogicAttribute &operator=(const LogicAttribute &);
  LogicAttribute(Symbol p1);
  ~LogicAttribute();
  virtual void accept(Visitor *v);
  virtual  LogicAttribute  *clone() const;
  void swap(LogicAttribute &);
};

class FamilyAttribute : public Attribute
{
 public:
  Symbol symbol_;

  FamilyAttribute(const FamilyAttribute &);
  FamilyAttribute &operator=(const FamilyAttribute &);
  FamilyAttribute(Symbol p1);
  ~FamilyAttribute();
  virtual void accept(Visitor *v);
  virtual  FamilyAttribute  *clone() const;
  void swap(FamilyAttribute &);
};

class AssumptionAttribute : public Attribute
{
 public:
  Term *term_;

  AssumptionAttribute(const AssumptionAttribute &);
  AssumptionAttribute &operator=(const AssumptionAttribute &);
  AssumptionAttribute(Term *p1);
  ~AssumptionAttribute();
  virtual void accept(Visitor *v);
  virtual  AssumptionAttribute  *clone() const;
  void swap(AssumptionAttribute &);
};

class FormulaAttribute : public Attribute
{
 public:
  Term *term_;

  FormulaAttribute(const FormulaAttribute &);
  FormulaAttribute &operator=(const FormulaAttribute &);
  FormulaAttribute(Term *p1);
  ~FormulaAttribute();
  virtual void accept(Visitor *v);
  virtual  FormulaAttribute  *clone() const;
  void swap(FormulaAttribute &);
};

class StatusAttribute : public Attribute
{
 public:
  Status *status_;

  StatusAttribute(const StatusAttribute &);
  StatusAttribute &operator=(const StatusAttribute &);
  StatusAttribute(Status *p1);
  ~StatusAttribute();
  virtual void accept(Visitor *v);
  virtual  StatusAttribute  *clone() const;
  void swap(StatusAttribute &);
};

class ExtraSortsAttribute : public Attribute
{
 public:
  ListSortDeclC *listsortdeclc_;

  ExtraSortsAttribute(const ExtraSortsAttribute &);
  ExtraSortsAttribute &operator=(const ExtraSortsAttribute &);
  ExtraSortsAttribute(ListSortDeclC *p1);
  ~ExtraSortsAttribute();
  virtual void accept(Visitor *v);
  virtual  ExtraSortsAttribute  *clone() const;
  void swap(ExtraSortsAttribute &);
};

class ExtraFunsAttribute : public Attribute
{
 public:
  ListFunctionDeclC *listfunctiondeclc_;

  ExtraFunsAttribute(const ExtraFunsAttribute &);
  ExtraFunsAttribute &operator=(const ExtraFunsAttribute &);
  ExtraFunsAttribute(ListFunctionDeclC *p1);
  ~ExtraFunsAttribute();
  virtual void accept(Visitor *v);
  virtual  ExtraFunsAttribute  *clone() const;
  void swap(ExtraFunsAttribute &);
};

class NotesAttribute : public Attribute
{
 public:
  String string_;

  NotesAttribute(const NotesAttribute &);
  NotesAttribute &operator=(const NotesAttribute &);
  NotesAttribute(String p1);
  ~NotesAttribute();
  virtual void accept(Visitor *v);
  virtual  NotesAttribute  *clone() const;
  void swap(NotesAttribute &);
};

class AnnotationAttribute : public Attribute
{
 public:
  Annotation *annotation_;

  AnnotationAttribute(const AnnotationAttribute &);
  AnnotationAttribute &operator=(const AnnotationAttribute &);
  AnnotationAttribute(Annotation *p1);
  ~AnnotationAttribute();
  virtual void accept(Visitor *v);
  virtual  AnnotationAttribute  *clone() const;
  void swap(AnnotationAttribute &);
};


class ListAttribute : public Visitable
{
 public:
  Attribute *attribute_;
  ListAttribute *listattribute_;

  ListAttribute(const ListAttribute &);
  ListAttribute &operator=(const ListAttribute &);
  ListAttribute(Attribute *p1, ListAttribute *p2);
  ListAttribute(Attribute *p);
  ~ListAttribute();
  ListAttribute* reverse();
  ListAttribute* reverse(ListAttribute *l);
  virtual void accept(Visitor *v);
  virtual ListAttribute *clone() const;
  void swap(ListAttribute &);
};
class Status : public Visitable {
public:
  virtual Status *clone() const = 0;
};

class SatStatus : public Status
{
 public:

  SatStatus(const SatStatus &);
  SatStatus &operator=(const SatStatus &);
  SatStatus();
  ~SatStatus();
  virtual void accept(Visitor *v);
  virtual  SatStatus  *clone() const;
  void swap(SatStatus &);
};

class UnSatStatus : public Status
{
 public:

  UnSatStatus(const UnSatStatus &);
  UnSatStatus &operator=(const UnSatStatus &);
  UnSatStatus();
  ~UnSatStatus();
  virtual void accept(Visitor *v);
  virtual  UnSatStatus  *clone() const;
  void swap(UnSatStatus &);
};

class UnknownStatus : public Status
{
 public:

  UnknownStatus(const UnknownStatus &);
  UnknownStatus &operator=(const UnknownStatus &);
  UnknownStatus();
  ~UnknownStatus();
  virtual void accept(Visitor *v);
  virtual  UnknownStatus  *clone() const;
  void swap(UnknownStatus &);
};


class Sort : public Visitable {
public:
  virtual Sort *clone() const = 0;
};

class IdentSort : public Sort
{
 public:
  Identifier *identifier_;

  IdentSort(const IdentSort &);
  IdentSort &operator=(const IdentSort &);
  IdentSort(Identifier *p1);
  ~IdentSort();
  virtual void accept(Visitor *v);
  virtual  IdentSort  *clone() const;
  void swap(IdentSort &);
};

class CompositeSort : public Sort
{
 public:
  Identifier *identifier_;
  ListSort *listsort_;

  CompositeSort(const CompositeSort &);
  CompositeSort &operator=(const CompositeSort &);
  CompositeSort(Identifier *p1, ListSort *p2);
  ~CompositeSort();
  virtual void accept(Visitor *v);
  virtual  CompositeSort  *clone() const;
  void swap(CompositeSort &);
};


class ListSort : public Visitable
{
 public:
  Sort *sort_;
  ListSort *listsort_;

  ListSort(const ListSort &);
  ListSort &operator=(const ListSort &);
  ListSort(Sort *p1, ListSort *p2);
  ListSort(Sort *p);
  ~ListSort();
  ListSort* reverse();
  ListSort* reverse(ListSort *l);
  virtual void accept(Visitor *v);
  virtual ListSort *clone() const;
  void swap(ListSort &);
};
class SortDeclC : public Visitable {
public:
  virtual SortDeclC *clone() const = 0;
};

class SortDecl : public SortDeclC
{
 public:
  Identifier *identifier_;
  Numeral numeral_;
  ListAnnotation *listannotation_;

  SortDecl(const SortDecl &);
  SortDecl &operator=(const SortDecl &);
  SortDecl(Identifier *p1, Numeral p2, ListAnnotation *p3);
  ~SortDecl();
  virtual void accept(Visitor *v);
  virtual  SortDecl  *clone() const;
  void swap(SortDecl &);
};

class SortSynonymDecl : public SortDeclC
{
 public:
  Identifier *identifier_;
  Sort *sort_;
  ListAnnotation *listannotation_;

  SortSynonymDecl(const SortSynonymDecl &);
  SortSynonymDecl &operator=(const SortSynonymDecl &);
  SortSynonymDecl(Identifier *p1, Sort *p2, ListAnnotation *p3);
  ~SortSynonymDecl();
  virtual void accept(Visitor *v);
  virtual  SortSynonymDecl  *clone() const;
  void swap(SortSynonymDecl &);
};


class ListSortDeclC : public Visitable
{
 public:
  SortDeclC *sortdeclc_;
  ListSortDeclC *listsortdeclc_;

  ListSortDeclC(const ListSortDeclC &);
  ListSortDeclC &operator=(const ListSortDeclC &);
  ListSortDeclC(SortDeclC *p1, ListSortDeclC *p2);
  ListSortDeclC(SortDeclC *p);
  ~ListSortDeclC();
  ListSortDeclC* reverse();
  ListSortDeclC* reverse(ListSortDeclC *l);
  virtual void accept(Visitor *v);
  virtual ListSortDeclC *clone() const;
  void swap(ListSortDeclC &);
};
class Term : public Visitable {
public:
  virtual Term *clone() const = 0;
};

class ConstantTerm : public Term
{
 public:
  SpecConstant *specconstant_;

  ConstantTerm(const ConstantTerm &);
  ConstantTerm &operator=(const ConstantTerm &);
  ConstantTerm(SpecConstant *p1);
  ~ConstantTerm();
  virtual void accept(Visitor *v);
  virtual  ConstantTerm  *clone() const;
  void swap(ConstantTerm &);
};

class NullaryTerm : public Term
{
 public:
  SymbolRef *symbolref_;

  NullaryTerm(const NullaryTerm &);
  NullaryTerm &operator=(const NullaryTerm &);
  NullaryTerm(SymbolRef *p1);
  ~NullaryTerm();
  virtual void accept(Visitor *v);
  virtual  NullaryTerm  *clone() const;
  void swap(NullaryTerm &);
};

class FunctionTerm : public Term
{
 public:
  SymbolRef *symbolref_;
  ListTerm *listterm_;

  FunctionTerm(const FunctionTerm &);
  FunctionTerm &operator=(const FunctionTerm &);
  FunctionTerm(SymbolRef *p1, ListTerm *p2);
  ~FunctionTerm();
  virtual void accept(Visitor *v);
  virtual  FunctionTerm  *clone() const;
  void swap(FunctionTerm &);
};

class LetTerm : public Term
{
 public:
  ListBindingC *listbindingc_;
  Term *term_;

  LetTerm(const LetTerm &);
  LetTerm &operator=(const LetTerm &);
  LetTerm(ListBindingC *p1, Term *p2);
  ~LetTerm();
  virtual void accept(Visitor *v);
  virtual  LetTerm  *clone() const;
  void swap(LetTerm &);
};

class QuantifierTerm : public Term
{
 public:
  Quantifier *quantifier_;
  ListSortedVariableC *listsortedvariablec_;
  Term *term_;

  QuantifierTerm(const QuantifierTerm &);
  QuantifierTerm &operator=(const QuantifierTerm &);
  QuantifierTerm(Quantifier *p1, ListSortedVariableC *p2, Term *p3);
  ~QuantifierTerm();
  virtual void accept(Visitor *v);
  virtual  QuantifierTerm  *clone() const;
  void swap(QuantifierTerm &);
};

class AnnotationTerm : public Term
{
 public:
  Term *term_;
  Annotation *annotation_;

  AnnotationTerm(const AnnotationTerm &);
  AnnotationTerm &operator=(const AnnotationTerm &);
  AnnotationTerm(Term *p1, Annotation *p2);
  ~AnnotationTerm();
  virtual void accept(Visitor *v);
  virtual  AnnotationTerm  *clone() const;
  void swap(AnnotationTerm &);
};


class ListTerm : public Visitable
{
 public:
  Term *term_;
  ListTerm *listterm_;

  ListTerm(const ListTerm &);
  ListTerm &operator=(const ListTerm &);
  ListTerm(Term *p1, ListTerm *p2);
  ListTerm(Term *p);
  ~ListTerm();
  ListTerm* reverse();
  ListTerm* reverse(ListTerm *l);
  virtual void accept(Visitor *v);
  virtual ListTerm *clone() const;
  void swap(ListTerm &);
};
class BindingC : public Visitable {
public:
  virtual BindingC *clone() const = 0;
};

class Binding : public BindingC
{
 public:
  Symbol symbol_;
  Term *term_;

  Binding(const Binding &);
  Binding &operator=(const Binding &);
  Binding(Symbol p1, Term *p2);
  ~Binding();
  virtual void accept(Visitor *v);
  virtual  Binding  *clone() const;
  void swap(Binding &);
};


class ListBindingC : public Visitable
{
 public:
  BindingC *bindingc_;
  ListBindingC *listbindingc_;

  ListBindingC(const ListBindingC &);
  ListBindingC &operator=(const ListBindingC &);
  ListBindingC(BindingC *p1, ListBindingC *p2);
  ListBindingC(BindingC *p);
  ~ListBindingC();
  ListBindingC* reverse();
  ListBindingC* reverse(ListBindingC *l);
  virtual void accept(Visitor *v);
  virtual ListBindingC *clone() const;
  void swap(ListBindingC &);
};
class Quantifier : public Visitable {
public:
  virtual Quantifier *clone() const = 0;
};

class AllQuantifier : public Quantifier
{
 public:

  AllQuantifier(const AllQuantifier &);
  AllQuantifier &operator=(const AllQuantifier &);
  AllQuantifier();
  ~AllQuantifier();
  virtual void accept(Visitor *v);
  virtual  AllQuantifier  *clone() const;
  void swap(AllQuantifier &);
};

class ExQuantifier : public Quantifier
{
 public:

  ExQuantifier(const ExQuantifier &);
  ExQuantifier &operator=(const ExQuantifier &);
  ExQuantifier();
  ~ExQuantifier();
  virtual void accept(Visitor *v);
  virtual  ExQuantifier  *clone() const;
  void swap(ExQuantifier &);
};


class SymbolRef : public Visitable {
public:
  virtual SymbolRef *clone() const = 0;
};

class IdentifierRef : public SymbolRef
{
 public:
  Identifier *identifier_;

  IdentifierRef(const IdentifierRef &);
  IdentifierRef &operator=(const IdentifierRef &);
  IdentifierRef(Identifier *p1);
  ~IdentifierRef();
  virtual void accept(Visitor *v);
  virtual  IdentifierRef  *clone() const;
  void swap(IdentifierRef &);
};

class CastIdentifierRef : public SymbolRef
{
 public:
  Identifier *identifier_;
  Sort *sort_;

  CastIdentifierRef(const CastIdentifierRef &);
  CastIdentifierRef &operator=(const CastIdentifierRef &);
  CastIdentifierRef(Identifier *p1, Sort *p2);
  ~CastIdentifierRef();
  virtual void accept(Visitor *v);
  virtual  CastIdentifierRef  *clone() const;
  void swap(CastIdentifierRef &);
};


class FunctionDeclC : public Visitable {
public:
  virtual FunctionDeclC *clone() const = 0;
};

class ConstantDecl : public FunctionDeclC
{
 public:
  SpecConstant *specconstant_;
  Sort *sort_;
  ListAnnotation *listannotation_;

  ConstantDecl(const ConstantDecl &);
  ConstantDecl &operator=(const ConstantDecl &);
  ConstantDecl(SpecConstant *p1, Sort *p2, ListAnnotation *p3);
  ~ConstantDecl();
  virtual void accept(Visitor *v);
  virtual  ConstantDecl  *clone() const;
  void swap(ConstantDecl &);
};

class MetaConstantDecl : public FunctionDeclC
{
 public:
  MetaConstant *metaconstant_;
  Sort *sort_;
  ListAnnotation *listannotation_;

  MetaConstantDecl(const MetaConstantDecl &);
  MetaConstantDecl &operator=(const MetaConstantDecl &);
  MetaConstantDecl(MetaConstant *p1, Sort *p2, ListAnnotation *p3);
  ~MetaConstantDecl();
  virtual void accept(Visitor *v);
  virtual  MetaConstantDecl  *clone() const;
  void swap(MetaConstantDecl &);
};

class FunctionDecl : public FunctionDeclC
{
 public:
  Identifier *identifier_;
  ListSort *listsort_;
  ListAnnotation *listannotation_;

  FunctionDecl(const FunctionDecl &);
  FunctionDecl &operator=(const FunctionDecl &);
  FunctionDecl(Identifier *p1, ListSort *p2, ListAnnotation *p3);
  ~FunctionDecl();
  virtual void accept(Visitor *v);
  virtual  FunctionDecl  *clone() const;
  void swap(FunctionDecl &);
};

class MacroDecl : public FunctionDeclC
{
 public:
  Identifier *identifier_;
  ListSortedVariableC *listsortedvariablec_;
  Term *term_;
  ListAnnotation *listannotation_;

  MacroDecl(const MacroDecl &);
  MacroDecl &operator=(const MacroDecl &);
  MacroDecl(Identifier *p1, ListSortedVariableC *p2, Term *p3, ListAnnotation *p4);
  ~MacroDecl();
  virtual void accept(Visitor *v);
  virtual  MacroDecl  *clone() const;
  void swap(MacroDecl &);
};


class ListFunctionDeclC : public Visitable
{
 public:
  FunctionDeclC *functiondeclc_;
  ListFunctionDeclC *listfunctiondeclc_;

  ListFunctionDeclC(const ListFunctionDeclC &);
  ListFunctionDeclC &operator=(const ListFunctionDeclC &);
  ListFunctionDeclC(FunctionDeclC *p1, ListFunctionDeclC *p2);
  ListFunctionDeclC(FunctionDeclC *p);
  ~ListFunctionDeclC();
  ListFunctionDeclC* reverse();
  ListFunctionDeclC* reverse(ListFunctionDeclC *l);
  virtual void accept(Visitor *v);
  virtual ListFunctionDeclC *clone() const;
  void swap(ListFunctionDeclC &);
};
class SortedVariableC : public Visitable {
public:
  virtual SortedVariableC *clone() const = 0;
};

class SortedVariable : public SortedVariableC
{
 public:
  Symbol symbol_;
  Sort *sort_;

  SortedVariable(const SortedVariable &);
  SortedVariable &operator=(const SortedVariable &);
  SortedVariable(Symbol p1, Sort *p2);
  ~SortedVariable();
  virtual void accept(Visitor *v);
  virtual  SortedVariable  *clone() const;
  void swap(SortedVariable &);
};


class ListSortedVariableC : public Visitable
{
 public:
  SortedVariableC *sortedvariablec_;
  ListSortedVariableC *listsortedvariablec_;

  ListSortedVariableC(const ListSortedVariableC &);
  ListSortedVariableC &operator=(const ListSortedVariableC &);
  ListSortedVariableC(SortedVariableC *p1, ListSortedVariableC *p2);
  ListSortedVariableC(SortedVariableC *p);
  ~ListSortedVariableC();
  ListSortedVariableC* reverse();
  ListSortedVariableC* reverse(ListSortedVariableC *l);
  virtual void accept(Visitor *v);
  virtual ListSortedVariableC *clone() const;
  void swap(ListSortedVariableC &);
};
class SpecConstant : public Visitable {
public:
  virtual SpecConstant *clone() const = 0;
};

class NumConstant : public SpecConstant
{
 public:
  Numeral numeral_;

  NumConstant(const NumConstant &);
  NumConstant &operator=(const NumConstant &);
  NumConstant(Numeral p1);
  ~NumConstant();
  virtual void accept(Visitor *v);
  virtual  NumConstant  *clone() const;
  void swap(NumConstant &);
};

class RatConstant : public SpecConstant
{
 public:
  Rational rational_;

  RatConstant(const RatConstant &);
  RatConstant &operator=(const RatConstant &);
  RatConstant(Rational p1);
  ~RatConstant();
  virtual void accept(Visitor *v);
  virtual  RatConstant  *clone() const;
  void swap(RatConstant &);
};

class HexConstant : public SpecConstant
{
 public:
  Hexadecimal hexadecimal_;

  HexConstant(const HexConstant &);
  HexConstant &operator=(const HexConstant &);
  HexConstant(Hexadecimal p1);
  ~HexConstant();
  virtual void accept(Visitor *v);
  virtual  HexConstant  *clone() const;
  void swap(HexConstant &);
};

class BinConstant : public SpecConstant
{
 public:
  Binary binary_;

  BinConstant(const BinConstant &);
  BinConstant &operator=(const BinConstant &);
  BinConstant(Binary p1);
  ~BinConstant();
  virtual void accept(Visitor *v);
  virtual  BinConstant  *clone() const;
  void swap(BinConstant &);
};

class StringConstant : public SpecConstant
{
 public:
  String string_;

  StringConstant(const StringConstant &);
  StringConstant &operator=(const StringConstant &);
  StringConstant(String p1);
  ~StringConstant();
  virtual void accept(Visitor *v);
  virtual  StringConstant  *clone() const;
  void swap(StringConstant &);
};


class MetaConstant : public Visitable {
public:
  virtual MetaConstant *clone() const = 0;
};

class NumMetaConstant : public MetaConstant
{
 public:

  NumMetaConstant(const NumMetaConstant &);
  NumMetaConstant &operator=(const NumMetaConstant &);
  NumMetaConstant();
  ~NumMetaConstant();
  virtual void accept(Visitor *v);
  virtual  NumMetaConstant  *clone() const;
  void swap(NumMetaConstant &);
};

class RatMetaConstant : public MetaConstant
{
 public:

  RatMetaConstant(const RatMetaConstant &);
  RatMetaConstant &operator=(const RatMetaConstant &);
  RatMetaConstant();
  ~RatMetaConstant();
  virtual void accept(Visitor *v);
  virtual  RatMetaConstant  *clone() const;
  void swap(RatMetaConstant &);
};

class HexMetaConstant : public MetaConstant
{
 public:

  HexMetaConstant(const HexMetaConstant &);
  HexMetaConstant &operator=(const HexMetaConstant &);
  HexMetaConstant();
  ~HexMetaConstant();
  virtual void accept(Visitor *v);
  virtual  HexMetaConstant  *clone() const;
  void swap(HexMetaConstant &);
};

class BinMetaConstant : public MetaConstant
{
 public:

  BinMetaConstant(const BinMetaConstant &);
  BinMetaConstant &operator=(const BinMetaConstant &);
  BinMetaConstant();
  ~BinMetaConstant();
  virtual void accept(Visitor *v);
  virtual  BinMetaConstant  *clone() const;
  void swap(BinMetaConstant &);
};

class StringMetaConstant : public MetaConstant
{
 public:

  StringMetaConstant(const StringMetaConstant &);
  StringMetaConstant &operator=(const StringMetaConstant &);
  StringMetaConstant();
  ~StringMetaConstant();
  virtual void accept(Visitor *v);
  virtual  StringMetaConstant  *clone() const;
  void swap(StringMetaConstant &);
};


class Identifier : public Visitable {
public:
  virtual Identifier *clone() const = 0;
};

class SymbolIdent : public Identifier
{
 public:
  Symbol symbol_;

  SymbolIdent(const SymbolIdent &);
  SymbolIdent &operator=(const SymbolIdent &);
  SymbolIdent(Symbol p1);
  ~SymbolIdent();
  virtual void accept(Visitor *v);
  virtual  SymbolIdent  *clone() const;
  void swap(SymbolIdent &);
};

class IndexIdent : public Identifier
{
 public:
  Symbol symbol_;
  ListIndexC *listindexc_;

  IndexIdent(const IndexIdent &);
  IndexIdent &operator=(const IndexIdent &);
  IndexIdent(Symbol p1, ListIndexC *p2);
  ~IndexIdent();
  virtual void accept(Visitor *v);
  virtual  IndexIdent  *clone() const;
  void swap(IndexIdent &);
};


class IndexC : public Visitable {
public:
  virtual IndexC *clone() const = 0;
};

class Index : public IndexC
{
 public:
  Numeral numeral_;

  Index(const Index &);
  Index &operator=(const Index &);
  Index(Numeral p1);
  ~Index();
  virtual void accept(Visitor *v);
  virtual  Index  *clone() const;
  void swap(Index &);
};


class ListIndexC : public Visitable
{
 public:
  IndexC *indexc_;
  ListIndexC *listindexc_;

  ListIndexC(const ListIndexC &);
  ListIndexC &operator=(const ListIndexC &);
  ListIndexC(IndexC *p1, ListIndexC *p2);
  ListIndexC(IndexC *p);
  ~ListIndexC();
  ListIndexC* reverse();
  ListIndexC* reverse(ListIndexC *l);
  virtual void accept(Visitor *v);
  virtual ListIndexC *clone() const;
  void swap(ListIndexC &);
};
class Annotation : public Visitable {
public:
  virtual Annotation *clone() const = 0;
};

class AttrAnnotation : public Annotation
{
 public:
  AnnotAttribute annotattribute_;
  AttrParam *attrparam_;

  AttrAnnotation(const AttrAnnotation &);
  AttrAnnotation &operator=(const AttrAnnotation &);
  AttrAnnotation(AnnotAttribute p1, AttrParam *p2);
  ~AttrAnnotation();
  virtual void accept(Visitor *v);
  virtual  AttrAnnotation  *clone() const;
  void swap(AttrAnnotation &);
};


class ListAnnotation : public Visitable
{
 public:
  Annotation *annotation_;
  ListAnnotation *listannotation_;

  ListAnnotation(const ListAnnotation &);
  ListAnnotation &operator=(const ListAnnotation &);
  ListAnnotation(Annotation *p1, ListAnnotation *p2);
  ListAnnotation(Annotation *p);
  ~ListAnnotation();
  ListAnnotation* reverse();
  ListAnnotation* reverse(ListAnnotation *l);
  virtual void accept(Visitor *v);
  virtual ListAnnotation *clone() const;
  void swap(ListAnnotation &);
};
class AttrParam : public Visitable {
public:
  virtual AttrParam *clone() const = 0;
};

class SomeAttrParam : public AttrParam
{
 public:
  SExpr *sexpr_;

  SomeAttrParam(const SomeAttrParam &);
  SomeAttrParam &operator=(const SomeAttrParam &);
  SomeAttrParam(SExpr *p1);
  ~SomeAttrParam();
  virtual void accept(Visitor *v);
  virtual  SomeAttrParam  *clone() const;
  void swap(SomeAttrParam &);
};

class NoAttrParam : public AttrParam
{
 public:

  NoAttrParam(const NoAttrParam &);
  NoAttrParam &operator=(const NoAttrParam &);
  NoAttrParam();
  ~NoAttrParam();
  virtual void accept(Visitor *v);
  virtual  NoAttrParam  *clone() const;
  void swap(NoAttrParam &);
};


class SExpr : public Visitable {
public:
  virtual SExpr *clone() const = 0;
};

class ConstantSExpr : public SExpr
{
 public:
  SpecConstant *specconstant_;

  ConstantSExpr(const ConstantSExpr &);
  ConstantSExpr &operator=(const ConstantSExpr &);
  ConstantSExpr(SpecConstant *p1);
  ~ConstantSExpr();
  virtual void accept(Visitor *v);
  virtual  ConstantSExpr  *clone() const;
  void swap(ConstantSExpr &);
};

class SymbolSExpr : public SExpr
{
 public:
  Symbol symbol_;

  SymbolSExpr(const SymbolSExpr &);
  SymbolSExpr &operator=(const SymbolSExpr &);
  SymbolSExpr(Symbol p1);
  ~SymbolSExpr();
  virtual void accept(Visitor *v);
  virtual  SymbolSExpr  *clone() const;
  void swap(SymbolSExpr &);
};

class ParenSExpr : public SExpr
{
 public:
  ListSExpr *listsexpr_;

  ParenSExpr(const ParenSExpr &);
  ParenSExpr &operator=(const ParenSExpr &);
  ParenSExpr(ListSExpr *p1);
  ~ParenSExpr();
  virtual void accept(Visitor *v);
  virtual  ParenSExpr  *clone() const;
  void swap(ParenSExpr &);
};


class ListSExpr : public Visitable
{
 public:
  SExpr *sexpr_;
  ListSExpr *listsexpr_;

  ListSExpr(const ListSExpr &);
  ListSExpr &operator=(const ListSExpr &);
  ListSExpr(SExpr *p1, ListSExpr *p2);
  ListSExpr(SExpr *p);
  ~ListSExpr();
  ListSExpr* reverse();
  ListSExpr* reverse(ListSExpr *l);
  virtual void accept(Visitor *v);
  virtual ListSExpr *clone() const;
  void swap(ListSExpr &);
};


#endif
