//C++ Abstract Syntax Implementation generated by the BNF Converter.
#include <algorithm>
#include "Absyn.H"

/********************   Benchmark    ********************/
Benchmark::Benchmark(Symbol p1, ListAttribute *p2) { symbol_ = p1; listattribute_ = p2; }
Benchmark::Benchmark(const Benchmark & other) {   symbol_ = other.symbol_;
  listattribute_ = other.listattribute_->clone();

}
Benchmark &Benchmark::operator=(const Benchmark & other) {
  Benchmark tmp(other);
  swap(tmp);
  return *this;
}
void Benchmark::swap(Benchmark & other) {
  std::swap(symbol_, other.symbol_);
  std::swap(listattribute_, other.listattribute_);

}

Benchmark::~Benchmark() { delete(listattribute_); }

void Benchmark::accept(Visitor *v) { v->visitBenchmark(this); }
Benchmark *Benchmark::clone() const {
  return new Benchmark(*this);
}

/********************   LogicAttribute    ********************/
LogicAttribute::LogicAttribute(Symbol p1) { symbol_ = p1; }
LogicAttribute::LogicAttribute(const LogicAttribute & other) {   symbol_ = other.symbol_;

}
LogicAttribute &LogicAttribute::operator=(const LogicAttribute & other) {
  LogicAttribute tmp(other);
  swap(tmp);
  return *this;
}
void LogicAttribute::swap(LogicAttribute & other) {
  std::swap(symbol_, other.symbol_);

}

LogicAttribute::~LogicAttribute() { }

void LogicAttribute::accept(Visitor *v) { v->visitLogicAttribute(this); }
LogicAttribute *LogicAttribute::clone() const {
  return new LogicAttribute(*this);
}

/********************   FamilyAttribute    ********************/
FamilyAttribute::FamilyAttribute(Symbol p1) { symbol_ = p1; }
FamilyAttribute::FamilyAttribute(const FamilyAttribute & other) {   symbol_ = other.symbol_;

}
FamilyAttribute &FamilyAttribute::operator=(const FamilyAttribute & other) {
  FamilyAttribute tmp(other);
  swap(tmp);
  return *this;
}
void FamilyAttribute::swap(FamilyAttribute & other) {
  std::swap(symbol_, other.symbol_);

}

FamilyAttribute::~FamilyAttribute() { }

void FamilyAttribute::accept(Visitor *v) { v->visitFamilyAttribute(this); }
FamilyAttribute *FamilyAttribute::clone() const {
  return new FamilyAttribute(*this);
}

/********************   AssumptionAttribute    ********************/
AssumptionAttribute::AssumptionAttribute(Term *p1) { term_ = p1; }
AssumptionAttribute::AssumptionAttribute(const AssumptionAttribute & other) {   term_ = other.term_->clone();

}
AssumptionAttribute &AssumptionAttribute::operator=(const AssumptionAttribute & other) {
  AssumptionAttribute tmp(other);
  swap(tmp);
  return *this;
}
void AssumptionAttribute::swap(AssumptionAttribute & other) {
  std::swap(term_, other.term_);

}

AssumptionAttribute::~AssumptionAttribute() { delete(term_); }

void AssumptionAttribute::accept(Visitor *v) { v->visitAssumptionAttribute(this); }
AssumptionAttribute *AssumptionAttribute::clone() const {
  return new AssumptionAttribute(*this);
}

/********************   FormulaAttribute    ********************/
FormulaAttribute::FormulaAttribute(Term *p1) { term_ = p1; }
FormulaAttribute::FormulaAttribute(const FormulaAttribute & other) {   term_ = other.term_->clone();

}
FormulaAttribute &FormulaAttribute::operator=(const FormulaAttribute & other) {
  FormulaAttribute tmp(other);
  swap(tmp);
  return *this;
}
void FormulaAttribute::swap(FormulaAttribute & other) {
  std::swap(term_, other.term_);

}

FormulaAttribute::~FormulaAttribute() { delete(term_); }

void FormulaAttribute::accept(Visitor *v) { v->visitFormulaAttribute(this); }
FormulaAttribute *FormulaAttribute::clone() const {
  return new FormulaAttribute(*this);
}

/********************   StatusAttribute    ********************/
StatusAttribute::StatusAttribute(Status *p1) { status_ = p1; }
StatusAttribute::StatusAttribute(const StatusAttribute & other) {   status_ = other.status_->clone();

}
StatusAttribute &StatusAttribute::operator=(const StatusAttribute & other) {
  StatusAttribute tmp(other);
  swap(tmp);
  return *this;
}
void StatusAttribute::swap(StatusAttribute & other) {
  std::swap(status_, other.status_);

}

StatusAttribute::~StatusAttribute() { delete(status_); }

void StatusAttribute::accept(Visitor *v) { v->visitStatusAttribute(this); }
StatusAttribute *StatusAttribute::clone() const {
  return new StatusAttribute(*this);
}

/********************   ExtraSortsAttribute    ********************/
ExtraSortsAttribute::ExtraSortsAttribute(ListSortDeclC *p1) { listsortdeclc_ = p1; }
ExtraSortsAttribute::ExtraSortsAttribute(const ExtraSortsAttribute & other) {   listsortdeclc_ = other.listsortdeclc_->clone();

}
ExtraSortsAttribute &ExtraSortsAttribute::operator=(const ExtraSortsAttribute & other) {
  ExtraSortsAttribute tmp(other);
  swap(tmp);
  return *this;
}
void ExtraSortsAttribute::swap(ExtraSortsAttribute & other) {
  std::swap(listsortdeclc_, other.listsortdeclc_);

}

ExtraSortsAttribute::~ExtraSortsAttribute() { delete(listsortdeclc_); }

void ExtraSortsAttribute::accept(Visitor *v) { v->visitExtraSortsAttribute(this); }
ExtraSortsAttribute *ExtraSortsAttribute::clone() const {
  return new ExtraSortsAttribute(*this);
}

/********************   ExtraFunsAttribute    ********************/
ExtraFunsAttribute::ExtraFunsAttribute(ListFunctionDeclC *p1) { listfunctiondeclc_ = p1; }
ExtraFunsAttribute::ExtraFunsAttribute(const ExtraFunsAttribute & other) {   listfunctiondeclc_ = other.listfunctiondeclc_->clone();

}
ExtraFunsAttribute &ExtraFunsAttribute::operator=(const ExtraFunsAttribute & other) {
  ExtraFunsAttribute tmp(other);
  swap(tmp);
  return *this;
}
void ExtraFunsAttribute::swap(ExtraFunsAttribute & other) {
  std::swap(listfunctiondeclc_, other.listfunctiondeclc_);

}

ExtraFunsAttribute::~ExtraFunsAttribute() { delete(listfunctiondeclc_); }

void ExtraFunsAttribute::accept(Visitor *v) { v->visitExtraFunsAttribute(this); }
ExtraFunsAttribute *ExtraFunsAttribute::clone() const {
  return new ExtraFunsAttribute(*this);
}

/********************   NotesAttribute    ********************/
NotesAttribute::NotesAttribute(String p1) { string_ = p1; }
NotesAttribute::NotesAttribute(const NotesAttribute & other) {   string_ = other.string_;

}
NotesAttribute &NotesAttribute::operator=(const NotesAttribute & other) {
  NotesAttribute tmp(other);
  swap(tmp);
  return *this;
}
void NotesAttribute::swap(NotesAttribute & other) {
  std::swap(string_, other.string_);

}

NotesAttribute::~NotesAttribute() { }

void NotesAttribute::accept(Visitor *v) { v->visitNotesAttribute(this); }
NotesAttribute *NotesAttribute::clone() const {
  return new NotesAttribute(*this);
}

/********************   AnnotationAttribute    ********************/
AnnotationAttribute::AnnotationAttribute(Annotation *p1) { annotation_ = p1; }
AnnotationAttribute::AnnotationAttribute(const AnnotationAttribute & other) {   annotation_ = other.annotation_->clone();

}
AnnotationAttribute &AnnotationAttribute::operator=(const AnnotationAttribute & other) {
  AnnotationAttribute tmp(other);
  swap(tmp);
  return *this;
}
void AnnotationAttribute::swap(AnnotationAttribute & other) {
  std::swap(annotation_, other.annotation_);

}

AnnotationAttribute::~AnnotationAttribute() { delete(annotation_); }

void AnnotationAttribute::accept(Visitor *v) { v->visitAnnotationAttribute(this); }
AnnotationAttribute *AnnotationAttribute::clone() const {
  return new AnnotationAttribute(*this);
}

/********************   ListAttribute    ********************/
ListAttribute::ListAttribute(Attribute *p1, ListAttribute *p2) { attribute_ = p1; listattribute_ = p2; }
ListAttribute::ListAttribute(const ListAttribute & other) {   attribute_ = other.attribute_->clone();
  listattribute_ = other.listattribute_->clone();

}
ListAttribute &ListAttribute::operator=(const ListAttribute & other) {
  ListAttribute tmp(other);
  swap(tmp);
  return *this;
}
void ListAttribute::swap(ListAttribute & other) {
  std::swap(attribute_, other.attribute_);
  std::swap(listattribute_, other.listattribute_);

}

ListAttribute::~ListAttribute() { delete(attribute_); delete(listattribute_); }
ListAttribute::ListAttribute(Attribute *p)
{
  attribute_ = p;
  listattribute_= 0;
}
ListAttribute* ListAttribute::reverse()
{
  if (listattribute_ == 0) return this;
  else
  {
    ListAttribute *tmp = listattribute_->reverse(this);
    listattribute_ = 0;
    return tmp;
  }
}

ListAttribute* ListAttribute::reverse(ListAttribute* prev)
{
  if (listattribute_ == 0)
  {
    listattribute_ = prev;
    return this;
  }
  else
  {
    ListAttribute *tmp = listattribute_->reverse(this);
    listattribute_ = prev;
    return tmp;
  }
}


void ListAttribute::accept(Visitor *v) { v->visitListAttribute(this); }
ListAttribute *ListAttribute::clone() const {
  return new ListAttribute(*this);
}

/********************   SatStatus    ********************/
SatStatus::SatStatus() { }
SatStatus::SatStatus(const SatStatus & other) { 
}
SatStatus &SatStatus::operator=(const SatStatus & other) {
  SatStatus tmp(other);
  swap(tmp);
  return *this;
}
void SatStatus::swap(SatStatus & other) {

}

SatStatus::~SatStatus() { }

void SatStatus::accept(Visitor *v) { v->visitSatStatus(this); }
SatStatus *SatStatus::clone() const {
  return new SatStatus(*this);
}

/********************   UnSatStatus    ********************/
UnSatStatus::UnSatStatus() { }
UnSatStatus::UnSatStatus(const UnSatStatus & other) { 
}
UnSatStatus &UnSatStatus::operator=(const UnSatStatus & other) {
  UnSatStatus tmp(other);
  swap(tmp);
  return *this;
}
void UnSatStatus::swap(UnSatStatus & other) {

}

UnSatStatus::~UnSatStatus() { }

void UnSatStatus::accept(Visitor *v) { v->visitUnSatStatus(this); }
UnSatStatus *UnSatStatus::clone() const {
  return new UnSatStatus(*this);
}

/********************   UnknownStatus    ********************/
UnknownStatus::UnknownStatus() { }
UnknownStatus::UnknownStatus(const UnknownStatus & other) { 
}
UnknownStatus &UnknownStatus::operator=(const UnknownStatus & other) {
  UnknownStatus tmp(other);
  swap(tmp);
  return *this;
}
void UnknownStatus::swap(UnknownStatus & other) {

}

UnknownStatus::~UnknownStatus() { }

void UnknownStatus::accept(Visitor *v) { v->visitUnknownStatus(this); }
UnknownStatus *UnknownStatus::clone() const {
  return new UnknownStatus(*this);
}

/********************   IdentSort    ********************/
IdentSort::IdentSort(Identifier *p1) { identifier_ = p1; }
IdentSort::IdentSort(const IdentSort & other) {   identifier_ = other.identifier_->clone();

}
IdentSort &IdentSort::operator=(const IdentSort & other) {
  IdentSort tmp(other);
  swap(tmp);
  return *this;
}
void IdentSort::swap(IdentSort & other) {
  std::swap(identifier_, other.identifier_);

}

IdentSort::~IdentSort() { delete(identifier_); }

void IdentSort::accept(Visitor *v) { v->visitIdentSort(this); }
IdentSort *IdentSort::clone() const {
  return new IdentSort(*this);
}

/********************   CompositeSort    ********************/
CompositeSort::CompositeSort(Identifier *p1, ListSort *p2) { identifier_ = p1; listsort_ = p2; }
CompositeSort::CompositeSort(const CompositeSort & other) {   identifier_ = other.identifier_->clone();
  listsort_ = other.listsort_->clone();

}
CompositeSort &CompositeSort::operator=(const CompositeSort & other) {
  CompositeSort tmp(other);
  swap(tmp);
  return *this;
}
void CompositeSort::swap(CompositeSort & other) {
  std::swap(identifier_, other.identifier_);
  std::swap(listsort_, other.listsort_);

}

CompositeSort::~CompositeSort() { delete(identifier_); delete(listsort_); }

void CompositeSort::accept(Visitor *v) { v->visitCompositeSort(this); }
CompositeSort *CompositeSort::clone() const {
  return new CompositeSort(*this);
}

/********************   ListSort    ********************/
ListSort::ListSort(Sort *p1, ListSort *p2) { sort_ = p1; listsort_ = p2; }
ListSort::ListSort(const ListSort & other) {   sort_ = other.sort_->clone();
  listsort_ = other.listsort_->clone();

}
ListSort &ListSort::operator=(const ListSort & other) {
  ListSort tmp(other);
  swap(tmp);
  return *this;
}
void ListSort::swap(ListSort & other) {
  std::swap(sort_, other.sort_);
  std::swap(listsort_, other.listsort_);

}

ListSort::~ListSort() { delete(sort_); delete(listsort_); }
ListSort::ListSort(Sort *p)
{
  sort_ = p;
  listsort_= 0;
}
ListSort* ListSort::reverse()
{
  if (listsort_ == 0) return this;
  else
  {
    ListSort *tmp = listsort_->reverse(this);
    listsort_ = 0;
    return tmp;
  }
}

ListSort* ListSort::reverse(ListSort* prev)
{
  if (listsort_ == 0)
  {
    listsort_ = prev;
    return this;
  }
  else
  {
    ListSort *tmp = listsort_->reverse(this);
    listsort_ = prev;
    return tmp;
  }
}


void ListSort::accept(Visitor *v) { v->visitListSort(this); }
ListSort *ListSort::clone() const {
  return new ListSort(*this);
}

/********************   SortDecl    ********************/
SortDecl::SortDecl(Identifier *p1, Numeral p2, ListAnnotation *p3) { identifier_ = p1; numeral_ = p2; listannotation_ = p3; }
SortDecl::SortDecl(const SortDecl & other) {   identifier_ = other.identifier_->clone();
  numeral_ = other.numeral_;
  listannotation_ = other.listannotation_->clone();

}
SortDecl &SortDecl::operator=(const SortDecl & other) {
  SortDecl tmp(other);
  swap(tmp);
  return *this;
}
void SortDecl::swap(SortDecl & other) {
  std::swap(identifier_, other.identifier_);
  std::swap(numeral_, other.numeral_);
  std::swap(listannotation_, other.listannotation_);

}

SortDecl::~SortDecl() { delete(identifier_); delete(listannotation_); }

void SortDecl::accept(Visitor *v) { v->visitSortDecl(this); }
SortDecl *SortDecl::clone() const {
  return new SortDecl(*this);
}

/********************   SortSynonymDecl    ********************/
SortSynonymDecl::SortSynonymDecl(Identifier *p1, Sort *p2, ListAnnotation *p3) { identifier_ = p1; sort_ = p2; listannotation_ = p3; }
SortSynonymDecl::SortSynonymDecl(const SortSynonymDecl & other) {   identifier_ = other.identifier_->clone();
  sort_ = other.sort_->clone();
  listannotation_ = other.listannotation_->clone();

}
SortSynonymDecl &SortSynonymDecl::operator=(const SortSynonymDecl & other) {
  SortSynonymDecl tmp(other);
  swap(tmp);
  return *this;
}
void SortSynonymDecl::swap(SortSynonymDecl & other) {
  std::swap(identifier_, other.identifier_);
  std::swap(sort_, other.sort_);
  std::swap(listannotation_, other.listannotation_);

}

SortSynonymDecl::~SortSynonymDecl() { delete(identifier_); delete(sort_); delete(listannotation_); }

void SortSynonymDecl::accept(Visitor *v) { v->visitSortSynonymDecl(this); }
SortSynonymDecl *SortSynonymDecl::clone() const {
  return new SortSynonymDecl(*this);
}

/********************   ListSortDeclC    ********************/
ListSortDeclC::ListSortDeclC(SortDeclC *p1, ListSortDeclC *p2) { sortdeclc_ = p1; listsortdeclc_ = p2; }
ListSortDeclC::ListSortDeclC(const ListSortDeclC & other) {   sortdeclc_ = other.sortdeclc_->clone();
  listsortdeclc_ = other.listsortdeclc_->clone();

}
ListSortDeclC &ListSortDeclC::operator=(const ListSortDeclC & other) {
  ListSortDeclC tmp(other);
  swap(tmp);
  return *this;
}
void ListSortDeclC::swap(ListSortDeclC & other) {
  std::swap(sortdeclc_, other.sortdeclc_);
  std::swap(listsortdeclc_, other.listsortdeclc_);

}

ListSortDeclC::~ListSortDeclC() { delete(sortdeclc_); delete(listsortdeclc_); }
ListSortDeclC::ListSortDeclC(SortDeclC *p)
{
  sortdeclc_ = p;
  listsortdeclc_= 0;
}
ListSortDeclC* ListSortDeclC::reverse()
{
  if (listsortdeclc_ == 0) return this;
  else
  {
    ListSortDeclC *tmp = listsortdeclc_->reverse(this);
    listsortdeclc_ = 0;
    return tmp;
  }
}

ListSortDeclC* ListSortDeclC::reverse(ListSortDeclC* prev)
{
  if (listsortdeclc_ == 0)
  {
    listsortdeclc_ = prev;
    return this;
  }
  else
  {
    ListSortDeclC *tmp = listsortdeclc_->reverse(this);
    listsortdeclc_ = prev;
    return tmp;
  }
}


void ListSortDeclC::accept(Visitor *v) { v->visitListSortDeclC(this); }
ListSortDeclC *ListSortDeclC::clone() const {
  return new ListSortDeclC(*this);
}

/********************   ConstantTerm    ********************/
ConstantTerm::ConstantTerm(SpecConstant *p1) { specconstant_ = p1; }
ConstantTerm::ConstantTerm(const ConstantTerm & other) {   specconstant_ = other.specconstant_->clone();

}
ConstantTerm &ConstantTerm::operator=(const ConstantTerm & other) {
  ConstantTerm tmp(other);
  swap(tmp);
  return *this;
}
void ConstantTerm::swap(ConstantTerm & other) {
  std::swap(specconstant_, other.specconstant_);

}

ConstantTerm::~ConstantTerm() { delete(specconstant_); }

void ConstantTerm::accept(Visitor *v) { v->visitConstantTerm(this); }
ConstantTerm *ConstantTerm::clone() const {
  return new ConstantTerm(*this);
}

/********************   NullaryTerm    ********************/
NullaryTerm::NullaryTerm(SymbolRef *p1) { symbolref_ = p1; }
NullaryTerm::NullaryTerm(const NullaryTerm & other) {   symbolref_ = other.symbolref_->clone();

}
NullaryTerm &NullaryTerm::operator=(const NullaryTerm & other) {
  NullaryTerm tmp(other);
  swap(tmp);
  return *this;
}
void NullaryTerm::swap(NullaryTerm & other) {
  std::swap(symbolref_, other.symbolref_);

}

NullaryTerm::~NullaryTerm() { delete(symbolref_); }

void NullaryTerm::accept(Visitor *v) { v->visitNullaryTerm(this); }
NullaryTerm *NullaryTerm::clone() const {
  return new NullaryTerm(*this);
}

/********************   FunctionTerm    ********************/
FunctionTerm::FunctionTerm(SymbolRef *p1, ListTerm *p2) { symbolref_ = p1; listterm_ = p2; }
FunctionTerm::FunctionTerm(const FunctionTerm & other) {   symbolref_ = other.symbolref_->clone();
  listterm_ = other.listterm_->clone();

}
FunctionTerm &FunctionTerm::operator=(const FunctionTerm & other) {
  FunctionTerm tmp(other);
  swap(tmp);
  return *this;
}
void FunctionTerm::swap(FunctionTerm & other) {
  std::swap(symbolref_, other.symbolref_);
  std::swap(listterm_, other.listterm_);

}

FunctionTerm::~FunctionTerm() { delete(symbolref_); delete(listterm_); }

void FunctionTerm::accept(Visitor *v) { v->visitFunctionTerm(this); }
FunctionTerm *FunctionTerm::clone() const {
  return new FunctionTerm(*this);
}

/********************   LetTerm    ********************/
LetTerm::LetTerm(ListBindingC *p1, Term *p2) { listbindingc_ = p1; term_ = p2; }
LetTerm::LetTerm(const LetTerm & other) {   listbindingc_ = other.listbindingc_->clone();
  term_ = other.term_->clone();

}
LetTerm &LetTerm::operator=(const LetTerm & other) {
  LetTerm tmp(other);
  swap(tmp);
  return *this;
}
void LetTerm::swap(LetTerm & other) {
  std::swap(listbindingc_, other.listbindingc_);
  std::swap(term_, other.term_);

}

LetTerm::~LetTerm() { delete(listbindingc_); delete(term_); }

void LetTerm::accept(Visitor *v) { v->visitLetTerm(this); }
LetTerm *LetTerm::clone() const {
  return new LetTerm(*this);
}

/********************   QuantifierTerm    ********************/
QuantifierTerm::QuantifierTerm(Quantifier *p1, ListSortedVariableC *p2, Term *p3) { quantifier_ = p1; listsortedvariablec_ = p2; term_ = p3; }
QuantifierTerm::QuantifierTerm(const QuantifierTerm & other) {   quantifier_ = other.quantifier_->clone();
  listsortedvariablec_ = other.listsortedvariablec_->clone();
  term_ = other.term_->clone();

}
QuantifierTerm &QuantifierTerm::operator=(const QuantifierTerm & other) {
  QuantifierTerm tmp(other);
  swap(tmp);
  return *this;
}
void QuantifierTerm::swap(QuantifierTerm & other) {
  std::swap(quantifier_, other.quantifier_);
  std::swap(listsortedvariablec_, other.listsortedvariablec_);
  std::swap(term_, other.term_);

}

QuantifierTerm::~QuantifierTerm() { delete(quantifier_); delete(listsortedvariablec_); delete(term_); }

void QuantifierTerm::accept(Visitor *v) { v->visitQuantifierTerm(this); }
QuantifierTerm *QuantifierTerm::clone() const {
  return new QuantifierTerm(*this);
}

/********************   AnnotationTerm    ********************/
AnnotationTerm::AnnotationTerm(Term *p1, Annotation *p2) { term_ = p1; annotation_ = p2; }
AnnotationTerm::AnnotationTerm(const AnnotationTerm & other) {   term_ = other.term_->clone();
  annotation_ = other.annotation_->clone();

}
AnnotationTerm &AnnotationTerm::operator=(const AnnotationTerm & other) {
  AnnotationTerm tmp(other);
  swap(tmp);
  return *this;
}
void AnnotationTerm::swap(AnnotationTerm & other) {
  std::swap(term_, other.term_);
  std::swap(annotation_, other.annotation_);

}

AnnotationTerm::~AnnotationTerm() { delete(term_); delete(annotation_); }

void AnnotationTerm::accept(Visitor *v) { v->visitAnnotationTerm(this); }
AnnotationTerm *AnnotationTerm::clone() const {
  return new AnnotationTerm(*this);
}

/********************   ListTerm    ********************/
ListTerm::ListTerm(Term *p1, ListTerm *p2) { term_ = p1; listterm_ = p2; }
ListTerm::ListTerm(const ListTerm & other) {   term_ = other.term_->clone();
  listterm_ = other.listterm_->clone();

}
ListTerm &ListTerm::operator=(const ListTerm & other) {
  ListTerm tmp(other);
  swap(tmp);
  return *this;
}
void ListTerm::swap(ListTerm & other) {
  std::swap(term_, other.term_);
  std::swap(listterm_, other.listterm_);

}

ListTerm::~ListTerm() { delete(term_); delete(listterm_); }
ListTerm::ListTerm(Term *p)
{
  term_ = p;
  listterm_= 0;
}
ListTerm* ListTerm::reverse()
{
  if (listterm_ == 0) return this;
  else
  {
    ListTerm *tmp = listterm_->reverse(this);
    listterm_ = 0;
    return tmp;
  }
}

ListTerm* ListTerm::reverse(ListTerm* prev)
{
  if (listterm_ == 0)
  {
    listterm_ = prev;
    return this;
  }
  else
  {
    ListTerm *tmp = listterm_->reverse(this);
    listterm_ = prev;
    return tmp;
  }
}


void ListTerm::accept(Visitor *v) { v->visitListTerm(this); }
ListTerm *ListTerm::clone() const {
  return new ListTerm(*this);
}

/********************   Binding    ********************/
Binding::Binding(Symbol p1, Term *p2) { symbol_ = p1; term_ = p2; }
Binding::Binding(const Binding & other) {   symbol_ = other.symbol_;
  term_ = other.term_->clone();

}
Binding &Binding::operator=(const Binding & other) {
  Binding tmp(other);
  swap(tmp);
  return *this;
}
void Binding::swap(Binding & other) {
  std::swap(symbol_, other.symbol_);
  std::swap(term_, other.term_);

}

Binding::~Binding() { delete(term_); }

void Binding::accept(Visitor *v) { v->visitBinding(this); }
Binding *Binding::clone() const {
  return new Binding(*this);
}

/********************   ListBindingC    ********************/
ListBindingC::ListBindingC(BindingC *p1, ListBindingC *p2) { bindingc_ = p1; listbindingc_ = p2; }
ListBindingC::ListBindingC(const ListBindingC & other) {   bindingc_ = other.bindingc_->clone();
  listbindingc_ = other.listbindingc_->clone();

}
ListBindingC &ListBindingC::operator=(const ListBindingC & other) {
  ListBindingC tmp(other);
  swap(tmp);
  return *this;
}
void ListBindingC::swap(ListBindingC & other) {
  std::swap(bindingc_, other.bindingc_);
  std::swap(listbindingc_, other.listbindingc_);

}

ListBindingC::~ListBindingC() { delete(bindingc_); delete(listbindingc_); }
ListBindingC::ListBindingC(BindingC *p)
{
  bindingc_ = p;
  listbindingc_= 0;
}
ListBindingC* ListBindingC::reverse()
{
  if (listbindingc_ == 0) return this;
  else
  {
    ListBindingC *tmp = listbindingc_->reverse(this);
    listbindingc_ = 0;
    return tmp;
  }
}

ListBindingC* ListBindingC::reverse(ListBindingC* prev)
{
  if (listbindingc_ == 0)
  {
    listbindingc_ = prev;
    return this;
  }
  else
  {
    ListBindingC *tmp = listbindingc_->reverse(this);
    listbindingc_ = prev;
    return tmp;
  }
}


void ListBindingC::accept(Visitor *v) { v->visitListBindingC(this); }
ListBindingC *ListBindingC::clone() const {
  return new ListBindingC(*this);
}

/********************   AllQuantifier    ********************/
AllQuantifier::AllQuantifier() { }
AllQuantifier::AllQuantifier(const AllQuantifier & other) { 
}
AllQuantifier &AllQuantifier::operator=(const AllQuantifier & other) {
  AllQuantifier tmp(other);
  swap(tmp);
  return *this;
}
void AllQuantifier::swap(AllQuantifier & other) {

}

AllQuantifier::~AllQuantifier() { }

void AllQuantifier::accept(Visitor *v) { v->visitAllQuantifier(this); }
AllQuantifier *AllQuantifier::clone() const {
  return new AllQuantifier(*this);
}

/********************   ExQuantifier    ********************/
ExQuantifier::ExQuantifier() { }
ExQuantifier::ExQuantifier(const ExQuantifier & other) { 
}
ExQuantifier &ExQuantifier::operator=(const ExQuantifier & other) {
  ExQuantifier tmp(other);
  swap(tmp);
  return *this;
}
void ExQuantifier::swap(ExQuantifier & other) {

}

ExQuantifier::~ExQuantifier() { }

void ExQuantifier::accept(Visitor *v) { v->visitExQuantifier(this); }
ExQuantifier *ExQuantifier::clone() const {
  return new ExQuantifier(*this);
}

/********************   IdentifierRef    ********************/
IdentifierRef::IdentifierRef(Identifier *p1) { identifier_ = p1; }
IdentifierRef::IdentifierRef(const IdentifierRef & other) {   identifier_ = other.identifier_->clone();

}
IdentifierRef &IdentifierRef::operator=(const IdentifierRef & other) {
  IdentifierRef tmp(other);
  swap(tmp);
  return *this;
}
void IdentifierRef::swap(IdentifierRef & other) {
  std::swap(identifier_, other.identifier_);

}

IdentifierRef::~IdentifierRef() { delete(identifier_); }

void IdentifierRef::accept(Visitor *v) { v->visitIdentifierRef(this); }
IdentifierRef *IdentifierRef::clone() const {
  return new IdentifierRef(*this);
}

/********************   CastIdentifierRef    ********************/
CastIdentifierRef::CastIdentifierRef(Identifier *p1, Sort *p2) { identifier_ = p1; sort_ = p2; }
CastIdentifierRef::CastIdentifierRef(const CastIdentifierRef & other) {   identifier_ = other.identifier_->clone();
  sort_ = other.sort_->clone();

}
CastIdentifierRef &CastIdentifierRef::operator=(const CastIdentifierRef & other) {
  CastIdentifierRef tmp(other);
  swap(tmp);
  return *this;
}
void CastIdentifierRef::swap(CastIdentifierRef & other) {
  std::swap(identifier_, other.identifier_);
  std::swap(sort_, other.sort_);

}

CastIdentifierRef::~CastIdentifierRef() { delete(identifier_); delete(sort_); }

void CastIdentifierRef::accept(Visitor *v) { v->visitCastIdentifierRef(this); }
CastIdentifierRef *CastIdentifierRef::clone() const {
  return new CastIdentifierRef(*this);
}

/********************   ConstantDecl    ********************/
ConstantDecl::ConstantDecl(SpecConstant *p1, Sort *p2, ListAnnotation *p3) { specconstant_ = p1; sort_ = p2; listannotation_ = p3; }
ConstantDecl::ConstantDecl(const ConstantDecl & other) {   specconstant_ = other.specconstant_->clone();
  sort_ = other.sort_->clone();
  listannotation_ = other.listannotation_->clone();

}
ConstantDecl &ConstantDecl::operator=(const ConstantDecl & other) {
  ConstantDecl tmp(other);
  swap(tmp);
  return *this;
}
void ConstantDecl::swap(ConstantDecl & other) {
  std::swap(specconstant_, other.specconstant_);
  std::swap(sort_, other.sort_);
  std::swap(listannotation_, other.listannotation_);

}

ConstantDecl::~ConstantDecl() { delete(specconstant_); delete(sort_); delete(listannotation_); }

void ConstantDecl::accept(Visitor *v) { v->visitConstantDecl(this); }
ConstantDecl *ConstantDecl::clone() const {
  return new ConstantDecl(*this);
}

/********************   MetaConstantDecl    ********************/
MetaConstantDecl::MetaConstantDecl(MetaConstant *p1, Sort *p2, ListAnnotation *p3) { metaconstant_ = p1; sort_ = p2; listannotation_ = p3; }
MetaConstantDecl::MetaConstantDecl(const MetaConstantDecl & other) {   metaconstant_ = other.metaconstant_->clone();
  sort_ = other.sort_->clone();
  listannotation_ = other.listannotation_->clone();

}
MetaConstantDecl &MetaConstantDecl::operator=(const MetaConstantDecl & other) {
  MetaConstantDecl tmp(other);
  swap(tmp);
  return *this;
}
void MetaConstantDecl::swap(MetaConstantDecl & other) {
  std::swap(metaconstant_, other.metaconstant_);
  std::swap(sort_, other.sort_);
  std::swap(listannotation_, other.listannotation_);

}

MetaConstantDecl::~MetaConstantDecl() { delete(metaconstant_); delete(sort_); delete(listannotation_); }

void MetaConstantDecl::accept(Visitor *v) { v->visitMetaConstantDecl(this); }
MetaConstantDecl *MetaConstantDecl::clone() const {
  return new MetaConstantDecl(*this);
}

/********************   FunctionDecl    ********************/
FunctionDecl::FunctionDecl(Identifier *p1, ListSort *p2, ListAnnotation *p3) { identifier_ = p1; listsort_ = p2; listannotation_ = p3; }
FunctionDecl::FunctionDecl(const FunctionDecl & other) {   identifier_ = other.identifier_->clone();
  listsort_ = other.listsort_->clone();
  listannotation_ = other.listannotation_->clone();

}
FunctionDecl &FunctionDecl::operator=(const FunctionDecl & other) {
  FunctionDecl tmp(other);
  swap(tmp);
  return *this;
}
void FunctionDecl::swap(FunctionDecl & other) {
  std::swap(identifier_, other.identifier_);
  std::swap(listsort_, other.listsort_);
  std::swap(listannotation_, other.listannotation_);

}

FunctionDecl::~FunctionDecl() { delete(identifier_); delete(listsort_); delete(listannotation_); }

void FunctionDecl::accept(Visitor *v) { v->visitFunctionDecl(this); }
FunctionDecl *FunctionDecl::clone() const {
  return new FunctionDecl(*this);
}

/********************   MacroDecl    ********************/
MacroDecl::MacroDecl(Identifier *p1, ListSortedVariableC *p2, Term *p3, ListAnnotation *p4) { identifier_ = p1; listsortedvariablec_ = p2; term_ = p3; listannotation_ = p4; }
MacroDecl::MacroDecl(const MacroDecl & other) {   identifier_ = other.identifier_->clone();
  listsortedvariablec_ = other.listsortedvariablec_->clone();
  term_ = other.term_->clone();
  listannotation_ = other.listannotation_->clone();

}
MacroDecl &MacroDecl::operator=(const MacroDecl & other) {
  MacroDecl tmp(other);
  swap(tmp);
  return *this;
}
void MacroDecl::swap(MacroDecl & other) {
  std::swap(identifier_, other.identifier_);
  std::swap(listsortedvariablec_, other.listsortedvariablec_);
  std::swap(term_, other.term_);
  std::swap(listannotation_, other.listannotation_);

}

MacroDecl::~MacroDecl() { delete(identifier_); delete(listsortedvariablec_); delete(term_); delete(listannotation_); }

void MacroDecl::accept(Visitor *v) { v->visitMacroDecl(this); }
MacroDecl *MacroDecl::clone() const {
  return new MacroDecl(*this);
}

/********************   ListFunctionDeclC    ********************/
ListFunctionDeclC::ListFunctionDeclC(FunctionDeclC *p1, ListFunctionDeclC *p2) { functiondeclc_ = p1; listfunctiondeclc_ = p2; }
ListFunctionDeclC::ListFunctionDeclC(const ListFunctionDeclC & other) {   functiondeclc_ = other.functiondeclc_->clone();
  listfunctiondeclc_ = other.listfunctiondeclc_->clone();

}
ListFunctionDeclC &ListFunctionDeclC::operator=(const ListFunctionDeclC & other) {
  ListFunctionDeclC tmp(other);
  swap(tmp);
  return *this;
}
void ListFunctionDeclC::swap(ListFunctionDeclC & other) {
  std::swap(functiondeclc_, other.functiondeclc_);
  std::swap(listfunctiondeclc_, other.listfunctiondeclc_);

}

ListFunctionDeclC::~ListFunctionDeclC() { delete(functiondeclc_); delete(listfunctiondeclc_); }
ListFunctionDeclC::ListFunctionDeclC(FunctionDeclC *p)
{
  functiondeclc_ = p;
  listfunctiondeclc_= 0;
}
ListFunctionDeclC* ListFunctionDeclC::reverse()
{
  if (listfunctiondeclc_ == 0) return this;
  else
  {
    ListFunctionDeclC *tmp = listfunctiondeclc_->reverse(this);
    listfunctiondeclc_ = 0;
    return tmp;
  }
}

ListFunctionDeclC* ListFunctionDeclC::reverse(ListFunctionDeclC* prev)
{
  if (listfunctiondeclc_ == 0)
  {
    listfunctiondeclc_ = prev;
    return this;
  }
  else
  {
    ListFunctionDeclC *tmp = listfunctiondeclc_->reverse(this);
    listfunctiondeclc_ = prev;
    return tmp;
  }
}


void ListFunctionDeclC::accept(Visitor *v) { v->visitListFunctionDeclC(this); }
ListFunctionDeclC *ListFunctionDeclC::clone() const {
  return new ListFunctionDeclC(*this);
}

/********************   SortedVariable    ********************/
SortedVariable::SortedVariable(Symbol p1, Sort *p2) { symbol_ = p1; sort_ = p2; }
SortedVariable::SortedVariable(const SortedVariable & other) {   symbol_ = other.symbol_;
  sort_ = other.sort_->clone();

}
SortedVariable &SortedVariable::operator=(const SortedVariable & other) {
  SortedVariable tmp(other);
  swap(tmp);
  return *this;
}
void SortedVariable::swap(SortedVariable & other) {
  std::swap(symbol_, other.symbol_);
  std::swap(sort_, other.sort_);

}

SortedVariable::~SortedVariable() { delete(sort_); }

void SortedVariable::accept(Visitor *v) { v->visitSortedVariable(this); }
SortedVariable *SortedVariable::clone() const {
  return new SortedVariable(*this);
}

/********************   ListSortedVariableC    ********************/
ListSortedVariableC::ListSortedVariableC(SortedVariableC *p1, ListSortedVariableC *p2) { sortedvariablec_ = p1; listsortedvariablec_ = p2; }
ListSortedVariableC::ListSortedVariableC(const ListSortedVariableC & other) {   sortedvariablec_ = other.sortedvariablec_->clone();
  listsortedvariablec_ = other.listsortedvariablec_->clone();

}
ListSortedVariableC &ListSortedVariableC::operator=(const ListSortedVariableC & other) {
  ListSortedVariableC tmp(other);
  swap(tmp);
  return *this;
}
void ListSortedVariableC::swap(ListSortedVariableC & other) {
  std::swap(sortedvariablec_, other.sortedvariablec_);
  std::swap(listsortedvariablec_, other.listsortedvariablec_);

}

ListSortedVariableC::~ListSortedVariableC() { delete(sortedvariablec_); delete(listsortedvariablec_); }
ListSortedVariableC::ListSortedVariableC(SortedVariableC *p)
{
  sortedvariablec_ = p;
  listsortedvariablec_= 0;
}
ListSortedVariableC* ListSortedVariableC::reverse()
{
  if (listsortedvariablec_ == 0) return this;
  else
  {
    ListSortedVariableC *tmp = listsortedvariablec_->reverse(this);
    listsortedvariablec_ = 0;
    return tmp;
  }
}

ListSortedVariableC* ListSortedVariableC::reverse(ListSortedVariableC* prev)
{
  if (listsortedvariablec_ == 0)
  {
    listsortedvariablec_ = prev;
    return this;
  }
  else
  {
    ListSortedVariableC *tmp = listsortedvariablec_->reverse(this);
    listsortedvariablec_ = prev;
    return tmp;
  }
}


void ListSortedVariableC::accept(Visitor *v) { v->visitListSortedVariableC(this); }
ListSortedVariableC *ListSortedVariableC::clone() const {
  return new ListSortedVariableC(*this);
}

/********************   NumConstant    ********************/
NumConstant::NumConstant(Numeral p1) { numeral_ = p1; }
NumConstant::NumConstant(const NumConstant & other) {   numeral_ = other.numeral_;

}
NumConstant &NumConstant::operator=(const NumConstant & other) {
  NumConstant tmp(other);
  swap(tmp);
  return *this;
}
void NumConstant::swap(NumConstant & other) {
  std::swap(numeral_, other.numeral_);

}

NumConstant::~NumConstant() { }

void NumConstant::accept(Visitor *v) { v->visitNumConstant(this); }
NumConstant *NumConstant::clone() const {
  return new NumConstant(*this);
}

/********************   RatConstant    ********************/
RatConstant::RatConstant(Rational p1) { rational_ = p1; }
RatConstant::RatConstant(const RatConstant & other) {   rational_ = other.rational_;

}
RatConstant &RatConstant::operator=(const RatConstant & other) {
  RatConstant tmp(other);
  swap(tmp);
  return *this;
}
void RatConstant::swap(RatConstant & other) {
  std::swap(rational_, other.rational_);

}

RatConstant::~RatConstant() { }

void RatConstant::accept(Visitor *v) { v->visitRatConstant(this); }
RatConstant *RatConstant::clone() const {
  return new RatConstant(*this);
}

/********************   HexConstant    ********************/
HexConstant::HexConstant(Hexadecimal p1) { hexadecimal_ = p1; }
HexConstant::HexConstant(const HexConstant & other) {   hexadecimal_ = other.hexadecimal_;

}
HexConstant &HexConstant::operator=(const HexConstant & other) {
  HexConstant tmp(other);
  swap(tmp);
  return *this;
}
void HexConstant::swap(HexConstant & other) {
  std::swap(hexadecimal_, other.hexadecimal_);

}

HexConstant::~HexConstant() { }

void HexConstant::accept(Visitor *v) { v->visitHexConstant(this); }
HexConstant *HexConstant::clone() const {
  return new HexConstant(*this);
}

/********************   BinConstant    ********************/
BinConstant::BinConstant(Binary p1) { binary_ = p1; }
BinConstant::BinConstant(const BinConstant & other) {   binary_ = other.binary_;

}
BinConstant &BinConstant::operator=(const BinConstant & other) {
  BinConstant tmp(other);
  swap(tmp);
  return *this;
}
void BinConstant::swap(BinConstant & other) {
  std::swap(binary_, other.binary_);

}

BinConstant::~BinConstant() { }

void BinConstant::accept(Visitor *v) { v->visitBinConstant(this); }
BinConstant *BinConstant::clone() const {
  return new BinConstant(*this);
}

/********************   StringConstant    ********************/
StringConstant::StringConstant(String p1) { string_ = p1; }
StringConstant::StringConstant(const StringConstant & other) {   string_ = other.string_;

}
StringConstant &StringConstant::operator=(const StringConstant & other) {
  StringConstant tmp(other);
  swap(tmp);
  return *this;
}
void StringConstant::swap(StringConstant & other) {
  std::swap(string_, other.string_);

}

StringConstant::~StringConstant() { }

void StringConstant::accept(Visitor *v) { v->visitStringConstant(this); }
StringConstant *StringConstant::clone() const {
  return new StringConstant(*this);
}

/********************   NumMetaConstant    ********************/
NumMetaConstant::NumMetaConstant() { }
NumMetaConstant::NumMetaConstant(const NumMetaConstant & other) { 
}
NumMetaConstant &NumMetaConstant::operator=(const NumMetaConstant & other) {
  NumMetaConstant tmp(other);
  swap(tmp);
  return *this;
}
void NumMetaConstant::swap(NumMetaConstant & other) {

}

NumMetaConstant::~NumMetaConstant() { }

void NumMetaConstant::accept(Visitor *v) { v->visitNumMetaConstant(this); }
NumMetaConstant *NumMetaConstant::clone() const {
  return new NumMetaConstant(*this);
}

/********************   RatMetaConstant    ********************/
RatMetaConstant::RatMetaConstant() { }
RatMetaConstant::RatMetaConstant(const RatMetaConstant & other) { 
}
RatMetaConstant &RatMetaConstant::operator=(const RatMetaConstant & other) {
  RatMetaConstant tmp(other);
  swap(tmp);
  return *this;
}
void RatMetaConstant::swap(RatMetaConstant & other) {

}

RatMetaConstant::~RatMetaConstant() { }

void RatMetaConstant::accept(Visitor *v) { v->visitRatMetaConstant(this); }
RatMetaConstant *RatMetaConstant::clone() const {
  return new RatMetaConstant(*this);
}

/********************   HexMetaConstant    ********************/
HexMetaConstant::HexMetaConstant() { }
HexMetaConstant::HexMetaConstant(const HexMetaConstant & other) { 
}
HexMetaConstant &HexMetaConstant::operator=(const HexMetaConstant & other) {
  HexMetaConstant tmp(other);
  swap(tmp);
  return *this;
}
void HexMetaConstant::swap(HexMetaConstant & other) {

}

HexMetaConstant::~HexMetaConstant() { }

void HexMetaConstant::accept(Visitor *v) { v->visitHexMetaConstant(this); }
HexMetaConstant *HexMetaConstant::clone() const {
  return new HexMetaConstant(*this);
}

/********************   BinMetaConstant    ********************/
BinMetaConstant::BinMetaConstant() { }
BinMetaConstant::BinMetaConstant(const BinMetaConstant & other) { 
}
BinMetaConstant &BinMetaConstant::operator=(const BinMetaConstant & other) {
  BinMetaConstant tmp(other);
  swap(tmp);
  return *this;
}
void BinMetaConstant::swap(BinMetaConstant & other) {

}

BinMetaConstant::~BinMetaConstant() { }

void BinMetaConstant::accept(Visitor *v) { v->visitBinMetaConstant(this); }
BinMetaConstant *BinMetaConstant::clone() const {
  return new BinMetaConstant(*this);
}

/********************   StringMetaConstant    ********************/
StringMetaConstant::StringMetaConstant() { }
StringMetaConstant::StringMetaConstant(const StringMetaConstant & other) { 
}
StringMetaConstant &StringMetaConstant::operator=(const StringMetaConstant & other) {
  StringMetaConstant tmp(other);
  swap(tmp);
  return *this;
}
void StringMetaConstant::swap(StringMetaConstant & other) {

}

StringMetaConstant::~StringMetaConstant() { }

void StringMetaConstant::accept(Visitor *v) { v->visitStringMetaConstant(this); }
StringMetaConstant *StringMetaConstant::clone() const {
  return new StringMetaConstant(*this);
}

/********************   SymbolIdent    ********************/
SymbolIdent::SymbolIdent(Symbol p1) { symbol_ = p1; }
SymbolIdent::SymbolIdent(const SymbolIdent & other) {   symbol_ = other.symbol_;

}
SymbolIdent &SymbolIdent::operator=(const SymbolIdent & other) {
  SymbolIdent tmp(other);
  swap(tmp);
  return *this;
}
void SymbolIdent::swap(SymbolIdent & other) {
  std::swap(symbol_, other.symbol_);

}

SymbolIdent::~SymbolIdent() { }

void SymbolIdent::accept(Visitor *v) { v->visitSymbolIdent(this); }
SymbolIdent *SymbolIdent::clone() const {
  return new SymbolIdent(*this);
}

/********************   IndexIdent    ********************/
IndexIdent::IndexIdent(Symbol p1, ListIndexC *p2) { symbol_ = p1; listindexc_ = p2; }
IndexIdent::IndexIdent(const IndexIdent & other) {   symbol_ = other.symbol_;
  listindexc_ = other.listindexc_->clone();

}
IndexIdent &IndexIdent::operator=(const IndexIdent & other) {
  IndexIdent tmp(other);
  swap(tmp);
  return *this;
}
void IndexIdent::swap(IndexIdent & other) {
  std::swap(symbol_, other.symbol_);
  std::swap(listindexc_, other.listindexc_);

}

IndexIdent::~IndexIdent() { delete(listindexc_); }

void IndexIdent::accept(Visitor *v) { v->visitIndexIdent(this); }
IndexIdent *IndexIdent::clone() const {
  return new IndexIdent(*this);
}

/********************   Index    ********************/
Index::Index(Numeral p1) { numeral_ = p1; }
Index::Index(const Index & other) {   numeral_ = other.numeral_;

}
Index &Index::operator=(const Index & other) {
  Index tmp(other);
  swap(tmp);
  return *this;
}
void Index::swap(Index & other) {
  std::swap(numeral_, other.numeral_);

}

Index::~Index() { }

void Index::accept(Visitor *v) { v->visitIndex(this); }
Index *Index::clone() const {
  return new Index(*this);
}

/********************   ListIndexC    ********************/
ListIndexC::ListIndexC(IndexC *p1, ListIndexC *p2) { indexc_ = p1; listindexc_ = p2; }
ListIndexC::ListIndexC(const ListIndexC & other) {   indexc_ = other.indexc_->clone();
  listindexc_ = other.listindexc_->clone();

}
ListIndexC &ListIndexC::operator=(const ListIndexC & other) {
  ListIndexC tmp(other);
  swap(tmp);
  return *this;
}
void ListIndexC::swap(ListIndexC & other) {
  std::swap(indexc_, other.indexc_);
  std::swap(listindexc_, other.listindexc_);

}

ListIndexC::~ListIndexC() { delete(indexc_); delete(listindexc_); }
ListIndexC::ListIndexC(IndexC *p)
{
  indexc_ = p;
  listindexc_= 0;
}
ListIndexC* ListIndexC::reverse()
{
  if (listindexc_ == 0) return this;
  else
  {
    ListIndexC *tmp = listindexc_->reverse(this);
    listindexc_ = 0;
    return tmp;
  }
}

ListIndexC* ListIndexC::reverse(ListIndexC* prev)
{
  if (listindexc_ == 0)
  {
    listindexc_ = prev;
    return this;
  }
  else
  {
    ListIndexC *tmp = listindexc_->reverse(this);
    listindexc_ = prev;
    return tmp;
  }
}


void ListIndexC::accept(Visitor *v) { v->visitListIndexC(this); }
ListIndexC *ListIndexC::clone() const {
  return new ListIndexC(*this);
}

/********************   AttrAnnotation    ********************/
AttrAnnotation::AttrAnnotation(AnnotAttribute p1, AttrParam *p2) { annotattribute_ = p1; attrparam_ = p2; }
AttrAnnotation::AttrAnnotation(const AttrAnnotation & other) {   annotattribute_ = other.annotattribute_;
  attrparam_ = other.attrparam_->clone();

}
AttrAnnotation &AttrAnnotation::operator=(const AttrAnnotation & other) {
  AttrAnnotation tmp(other);
  swap(tmp);
  return *this;
}
void AttrAnnotation::swap(AttrAnnotation & other) {
  std::swap(annotattribute_, other.annotattribute_);
  std::swap(attrparam_, other.attrparam_);

}

AttrAnnotation::~AttrAnnotation() { delete(attrparam_); }

void AttrAnnotation::accept(Visitor *v) { v->visitAttrAnnotation(this); }
AttrAnnotation *AttrAnnotation::clone() const {
  return new AttrAnnotation(*this);
}

/********************   ListAnnotation    ********************/
ListAnnotation::ListAnnotation(Annotation *p1, ListAnnotation *p2) { annotation_ = p1; listannotation_ = p2; }
ListAnnotation::ListAnnotation(const ListAnnotation & other) {   annotation_ = other.annotation_->clone();
  listannotation_ = other.listannotation_->clone();

}
ListAnnotation &ListAnnotation::operator=(const ListAnnotation & other) {
  ListAnnotation tmp(other);
  swap(tmp);
  return *this;
}
void ListAnnotation::swap(ListAnnotation & other) {
  std::swap(annotation_, other.annotation_);
  std::swap(listannotation_, other.listannotation_);

}

ListAnnotation::~ListAnnotation() { delete(annotation_); delete(listannotation_); }
ListAnnotation::ListAnnotation(Annotation *p)
{
  annotation_ = p;
  listannotation_= 0;
}
ListAnnotation* ListAnnotation::reverse()
{
  if (listannotation_ == 0) return this;
  else
  {
    ListAnnotation *tmp = listannotation_->reverse(this);
    listannotation_ = 0;
    return tmp;
  }
}

ListAnnotation* ListAnnotation::reverse(ListAnnotation* prev)
{
  if (listannotation_ == 0)
  {
    listannotation_ = prev;
    return this;
  }
  else
  {
    ListAnnotation *tmp = listannotation_->reverse(this);
    listannotation_ = prev;
    return tmp;
  }
}


void ListAnnotation::accept(Visitor *v) { v->visitListAnnotation(this); }
ListAnnotation *ListAnnotation::clone() const {
  return new ListAnnotation(*this);
}

/********************   SomeAttrParam    ********************/
SomeAttrParam::SomeAttrParam(SExpr *p1) { sexpr_ = p1; }
SomeAttrParam::SomeAttrParam(const SomeAttrParam & other) {   sexpr_ = other.sexpr_->clone();

}
SomeAttrParam &SomeAttrParam::operator=(const SomeAttrParam & other) {
  SomeAttrParam tmp(other);
  swap(tmp);
  return *this;
}
void SomeAttrParam::swap(SomeAttrParam & other) {
  std::swap(sexpr_, other.sexpr_);

}

SomeAttrParam::~SomeAttrParam() { delete(sexpr_); }

void SomeAttrParam::accept(Visitor *v) { v->visitSomeAttrParam(this); }
SomeAttrParam *SomeAttrParam::clone() const {
  return new SomeAttrParam(*this);
}

/********************   NoAttrParam    ********************/
NoAttrParam::NoAttrParam() { }
NoAttrParam::NoAttrParam(const NoAttrParam & other) { 
}
NoAttrParam &NoAttrParam::operator=(const NoAttrParam & other) {
  NoAttrParam tmp(other);
  swap(tmp);
  return *this;
}
void NoAttrParam::swap(NoAttrParam & other) {

}

NoAttrParam::~NoAttrParam() { }

void NoAttrParam::accept(Visitor *v) { v->visitNoAttrParam(this); }
NoAttrParam *NoAttrParam::clone() const {
  return new NoAttrParam(*this);
}

/********************   ConstantSExpr    ********************/
ConstantSExpr::ConstantSExpr(SpecConstant *p1) { specconstant_ = p1; }
ConstantSExpr::ConstantSExpr(const ConstantSExpr & other) {   specconstant_ = other.specconstant_->clone();

}
ConstantSExpr &ConstantSExpr::operator=(const ConstantSExpr & other) {
  ConstantSExpr tmp(other);
  swap(tmp);
  return *this;
}
void ConstantSExpr::swap(ConstantSExpr & other) {
  std::swap(specconstant_, other.specconstant_);

}

ConstantSExpr::~ConstantSExpr() { delete(specconstant_); }

void ConstantSExpr::accept(Visitor *v) { v->visitConstantSExpr(this); }
ConstantSExpr *ConstantSExpr::clone() const {
  return new ConstantSExpr(*this);
}

/********************   SymbolSExpr    ********************/
SymbolSExpr::SymbolSExpr(Symbol p1) { symbol_ = p1; }
SymbolSExpr::SymbolSExpr(const SymbolSExpr & other) {   symbol_ = other.symbol_;

}
SymbolSExpr &SymbolSExpr::operator=(const SymbolSExpr & other) {
  SymbolSExpr tmp(other);
  swap(tmp);
  return *this;
}
void SymbolSExpr::swap(SymbolSExpr & other) {
  std::swap(symbol_, other.symbol_);

}

SymbolSExpr::~SymbolSExpr() { }

void SymbolSExpr::accept(Visitor *v) { v->visitSymbolSExpr(this); }
SymbolSExpr *SymbolSExpr::clone() const {
  return new SymbolSExpr(*this);
}

/********************   ParenSExpr    ********************/
ParenSExpr::ParenSExpr(ListSExpr *p1) { listsexpr_ = p1; }
ParenSExpr::ParenSExpr(const ParenSExpr & other) {   listsexpr_ = other.listsexpr_->clone();

}
ParenSExpr &ParenSExpr::operator=(const ParenSExpr & other) {
  ParenSExpr tmp(other);
  swap(tmp);
  return *this;
}
void ParenSExpr::swap(ParenSExpr & other) {
  std::swap(listsexpr_, other.listsexpr_);

}

ParenSExpr::~ParenSExpr() { delete(listsexpr_); }

void ParenSExpr::accept(Visitor *v) { v->visitParenSExpr(this); }
ParenSExpr *ParenSExpr::clone() const {
  return new ParenSExpr(*this);
}

/********************   ListSExpr    ********************/
ListSExpr::ListSExpr(SExpr *p1, ListSExpr *p2) { sexpr_ = p1; listsexpr_ = p2; }
ListSExpr::ListSExpr(const ListSExpr & other) {   sexpr_ = other.sexpr_->clone();
  listsexpr_ = other.listsexpr_->clone();

}
ListSExpr &ListSExpr::operator=(const ListSExpr & other) {
  ListSExpr tmp(other);
  swap(tmp);
  return *this;
}
void ListSExpr::swap(ListSExpr & other) {
  std::swap(sexpr_, other.sexpr_);
  std::swap(listsexpr_, other.listsexpr_);

}

ListSExpr::~ListSExpr() { delete(sexpr_); delete(listsexpr_); }
ListSExpr::ListSExpr(SExpr *p)
{
  sexpr_ = p;
  listsexpr_= 0;
}
ListSExpr* ListSExpr::reverse()
{
  if (listsexpr_ == 0) return this;
  else
  {
    ListSExpr *tmp = listsexpr_->reverse(this);
    listsexpr_ = 0;
    return tmp;
  }
}

ListSExpr* ListSExpr::reverse(ListSExpr* prev)
{
  if (listsexpr_ == 0)
  {
    listsexpr_ = prev;
    return this;
  }
  else
  {
    ListSExpr *tmp = listsexpr_->reverse(this);
    listsexpr_ = prev;
    return tmp;
  }
}


void ListSExpr::accept(Visitor *v) { v->visitListSExpr(this); }
ListSExpr *ListSExpr::clone() const {
  return new ListSExpr(*this);
}


