/**
 * This file is part of the SMT-LIB 2 preprocessor.
 * <http://www.cprover.org/SMT-LIB-LSM/>
 *
 * Copyright (C) 2009 Philipp Ruemmer <ph_r@gmx.net>
 *
 * The SMT-LIB 2 preprocessor is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * The SMT-LIB 2 preprocessor is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with the SMT-LIB 2 preprocessor.  If not, see <http://www.gnu.org/licenses/>.
 */

/**
 * Collection of the various code snippets that the SMT back-end uses
 */

#ifndef SMT_FILE_TEMPLATE
#define SMT_FILE_TEMPLATE 1

#include "../file-template.H"

#include <string>

namespace SMTBackend {

class FileTemplates {
public:
	static std::string basepath;

    const FileTemplate T_embedding;
    const FileTemplate Set_template;
    const FileTemplate Set_T_template;
    const FileTemplate List_T_template;
    const FileTemplate Map_S_T_template;
    const FileTemplate List_Set_T_template;

    FileTemplates();
};

}

#endif
