/**
 * This file is part of the SMT-LIB 2 preprocessor.
 * <http://www.cprover.org/SMT-LIB-LSM/>
 *
 * Copyright (C) 2009 Philipp Ruemmer <ph_r@gmx.net>
 *
 * The SMT-LIB 2 preprocessor is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * The SMT-LIB 2 preprocessor is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with the SMT-LIB 2 preprocessor.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "file-templates.H"

#include <string>

namespace SMTBackend {

using namespace std;

#ifdef WIN32
  string FileTemplates::basepath = "";
#else
  string FileTemplates::basepath = SMT_BACKEND_RESOURCES;
#endif

FileTemplates::FileTemplates()
    : T_embedding(basepath + "T-embedding-template.smt"),
      Set_template(basepath + "Set-template.smt"),
      Set_T_template(basepath + "Set_T-template.smt"),
      List_T_template(basepath + "List_T-template.smt"),
      Map_S_T_template(basepath + "Map_S_T-template.smt"),
      List_Set_T_template(basepath + "List_Set_T-template.smt") {}

}
