/**
 * This file is part of the SMT-LIB 2 preprocessor.
 * <http://www.cprover.org/SMT-LIB-LSM/>
 *
 * Copyright (C) 2009 Philipp Ruemmer <ph_r@gmx.net>
 *
 * The SMT-LIB 2 preprocessor is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * The SMT-LIB 2 preprocessor is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with the SMT-LIB 2 preprocessor.  If not, see <http://www.gnu.org/licenses/>.
 */

/**
 * Abstract superclass of all theories
 */

#ifndef THEORY
#define THEORY 1

#include "../refcounting.H"

namespace Resolver {
class Environment;
}

namespace SMTLibAbsyn {
class FunctionApp;
}

namespace Theories {

class FunctionVisitor;

class Theory {
public:

	/**
	 * Register symbols, including the symbols of sub-theories
	 */
    virtual void registerSymbols(Resolver::Environment &env) const = 0;

	/**
	 * Register symbols, excluding the symbols of sub-theories
	 */
    virtual void registerSymbolsLocally(Resolver::Environment &env) const = 0;
    virtual void visit(const CountingPtr<SMTLibAbsyn::FunctionApp>& node,
                       FunctionVisitor& visitor) const = 0;
};

}

#endif
